<?php

/**
 * @author Oleg Isaev
 * @contacts vk.com/id50416641, t.me/pandcar, github.com/pandcar
 */

class ExchangeRatesKZ
{
	protected	$atom,
				$rates = [];
	
	public function __construct($tmp_path)
	{
		$this->atom = new Atomic([
			'path_tmp' => $tmp_path,
		]);
	}
	
	public function get()
	{
		$bank_metods_list = preg_grep('~_bank$~i', get_class_methods($this));
		
		foreach ($bank_metods_list as $value)
		{
			$this->$value();
		}
		
		return $this->rates;
	}
	
	protected function add($name, $array)
	{
		$nit = [];
		
		foreach ($array as $key => $data)
		{
			$kit = [];
			
			foreach ($data as $key2 => $value)
			{
				$value = (float) str_replace(',', '.', $value);
				$kit[$key2] = number_format($value, 2, '.', '');
			}
			
			$nit[$key] = $kit;
		}
		
		$this->rates[$name] = $nit;
	}
	
	protected function monotone(&$string)
	{
		$string = str_replace(["\n","\t", "\r", ' '], '', $string);
	}
	
	protected function halykbank_bank()
	{
		$result = $this->atom->request([
			'url' => 'https://halykbank.kz/',
		]);
		
		$auth = $this->atom->request([
			'url' => 'https://backend.halykbank.kz/auth/anonymous?appKey=0123456789ABCDEFGHIGKLMN',
			'form' => 'json',
		]);
		
		$auth = $auth['data']['auth'];
		
		$data = $this->atom->request([
			'url' => 'https://backend.halykbank.kz/common/currency-history',
			'headers/merge' => [
				'Auth-Time: '.$auth['time'],
				'Auth-Token: '.$auth['token'],
				'Auth-User-Id: '.$auth['userId'],
			],
			'form' => 'json',
		]);
		
		$data = $data['data']['currencyHistory'][1]['privatePersons'];
		
		$this->add('Народный банк Казахстана', [
			[$data['RUB/KZT']['buy'], $data['RUB/KZT']['sell']],
			[$data['EUR/KZT']['buy'], $data['EUR/KZT']['sell']],
			[$data['USD/KZT']['buy'], $data['USD/KZT']['sell']],
		]);
	}
	
	protected function eximbank_bank()
	{
		$html = $this->atom->request('http://www.eximbank.kz/kursy_valyuty/kursy_valyut_v_obmennyh_punktah_');
		
		$this->monotone($html);
		
		$array = $this->atom->regexpAll(
			'"kurs_title">([^<]+)</td>', 
			$this->atom->regexp('col">Алматы</td>(.*?)</tr>', $html), 
			1
		);
		
		$this->add('Эксимбанк', [
			[$array[4], $array[5]], 
			[$array[2], $array[3]], 
			[$array[0], $array[1]]
		]);
	}
	
	protected function tengribank_bank()
	{
		$html = $this->atom->request('https://tengribank.kz/');
		
		$this->monotone($html);
		
		$array = $this->atom->regexpAll(
			'(RUR|EUR|USD)/KZT</td><td>([^<]+)</td><td>([^<]+)</td>', 
			$this->atom->regexp('<pclass="title">Курсыналичныхиностранныхвалют</p>(.*?)</table>', $html), 
			[2, 3]
		);
		
		$this->add('Tengri Bank', [
			[$array[0][1], $array[1][1]], 
			[$array[0][2], $array[1][2]], 
			[$array[0][0], $array[1][0]]
		]);
	}
	
	protected function deltabank_bank()
	{
		$array = $this->atom->request([
			'url' => 'http://www.deltabank.kz/ajax_get_rates.php',
			'form' => 'xml',
		]);
		
		$array = $array['rates']['group'];
		
		$this->add('Delta Bank', [
			[$array['buy']['RUR'], $array['sale']['RUR']], 
			[$array['buy']['EUR'], $array['sale']['EUR']], 
			[$array['buy']['USD'], $array['sale']['USD']]
		]);
	}
	
	protected function capitalbank_bank()
	{
		$html = $this->atom->request('http://capitalbank.kz/ru/kursy_valyut');
		
		$array = $this->atom->regexpAll(
			'(RUB|EUR|USD) ([^<]+)<', 
			$this->atom->regexp('>Наличная валюта</h4>(.*?)<div class="row">', $html), 
			2
		);
		
		$this->add('Capital Bank', [
			[$array[1], $array[4]], 
			[$array[2], $array[5]], 
			[$array[0], $array[3]]
		]);
	}
	
	protected function qazaqbanki_bank()
	{
		$html = $this->atom->request('http://qazaqbanki.kz/rus/');
		
		$this->monotone($html);
		
		$array = $this->atom->regexpAll(
			'(RUB|EUR|USD)</td><td>([^<]+)</td><td>([^<]+)</td>', 
			$this->atom->regexp('<tableid="currency-41"(.*?)</table>', $html), 
			[2, 3]
		);
		
		$this->add('Qazaq Banki', [
			[$array[0][0], $array[1][0]], 
			[$array[0][2], $array[1][2]], 
			[$array[0][1], $array[1][1]]
		]);
	}
	
	protected function bankrbk_bank()
	{
		$html = $this->atom->request('https://www.bankrbk.kz/rus');
		
		$this->monotone($html);
		
		$array = $this->atom->regexpAll(
			'(RUB|EUR|USD)</td><td>([^<]+)</td><td>/</td><td>([^<]+)</td>', 
			$this->atom->regexp('>Курсывалютвобменныхпунктах</td>(.*?)</table>', $html), 
			[2, 3]
		);
		
		$this->add('Bank RBK', [
			[$array[0][0], $array[1][0]], 
			[$array[0][2], $array[1][2]], 
			[$array[0][1], $array[1][1]]
		]);
	}
	
	protected function asiacreditbank_bank()
	{
		$html = $this->atom->request('http://www.asiacreditbank.kz/');
		
		$this->monotone($html);
		
		$array = $this->atom->regexpAll(
			'(RUB|EUR|USD)</td><tdclass="cl-2">([^<]+)</td>(.*?)<tdclass="cl-4">([^<]+)</td>', 
			$this->atom->regexp('<tableclass="valtexchange-town"id="exchange-11"(.*?)</table>', $html), 
			[2, 4]
		);
		
		$this->add('AsiaCredit Bank', [
			[$array[0][2], $array[1][2]], 
			[$array[0][1], $array[1][1]], 
			[$array[0][0], $array[1][0]]
		]);
	}
	
	protected function mig_bank()
	{
		$html = $this->atom->request('https://www.mig.kz/');
		
		$this->monotone($html);
		
		$array = $this->atom->regexpAll(
			'>([^<]+)</td><tdclass="currency">(RUB|EUR|USD)</td><tdclass="selldelta-neutral">([^<]+)<', 
			$html, 
			[1, 3]
		);
		
		$this->add('Пункт обмена валют МиГ', [
			[$array[0][2], $array[1][2]], 
			[$array[0][1], $array[1][1]], 
			[$array[0][0], $array[1][0]]
		]);
	}
	
	protected function eubank_bank()
	{
		$html = $this->atom->request('https://www.eubank.kz/');
		
		$this->monotone($html);
		
		$array = $this->atom->regexpAll(
			'(RUB|EUR|USD)<spanstyle="color:#dd1668">&nbsp;</span></td><td>([^<]+)</td><td>([^<]+)</td>', 
			$this->atom->regexp('">иностраннойвалютывобменныхпунктах<div(.*?)</table>', $html), 
			[2, 3]
		);
		
		$this->add('Евразийский банк', [
			[$array[0][2], $array[1][2]], 
			[$array[0][1], $array[1][1]], 
			[$array[0][0], $array[1][0]]
		]);
	}
	
	protected function bankastana_bank()
	{
		$html = $this->atom->request('https://www.bankastana.kz/');
		
		$this->monotone($html);
		
		$array = $this->atom->regexpAll(
			'<td>(RUB|EUR|USD)</td><tdstyle="([^"]+)">([^<]+)</td><tdstyle="([^"]+)">([^<]+)</td>', 
			$this->atom->regexp('<divid="exchange_21"(.*?)<divid', $html), 
			[3, 5]
		);
		
		$this->add('БанкАстаны', [
			[$array[0][2], $array[1][2]], 
			[$array[0][1], $array[1][1]], 
			[$array[0][0], $array[1][0]]
		]);
	}
	
	protected function alfabank_bank()
	{
		$html = $this->atom->request('https://www.alfabank.kz/footer/valuta');
		
		$this->monotone($html);
		
		$array = $this->atom->regexpAll(
			'<td>(RUB|EUR|USD)</td><td>([^<]+)</td><td>([^<]+)</td>', 
			$this->atom->regexp('вобменномпункте(|\*):</th>(.*?)</table>', $html, 2), 
			[2, 3]
		);
		
		$this->add('АльфаБанк', [
			[$array[0][2], $array[1][2]], 
			[$array[0][1], $array[1][1]], 
			[$array[0][0], $array[1][0]]
		]);
	}
	
	protected function bankvtb_bank()
	{
		$html = $this->atom->request('http://www.vtb-bank.kz/');
		
		$this->monotone($html);
		
		$array = $this->atom->regexpAll(
			'(RUB|EUR|USD)/KZT</a></th><td><spanclass="num">([^<]+)</span><spanclass="icon-"></span></td><td><spanclass="num">([^<]+)</span>', 
			$html, 
			[2, 3]
		);
		
		$this->add('ВТБ - Казахстан', [
			[$array[0][2], $array[1][2]], 
			[$array[0][1], $array[1][1]], 
			[$array[0][0], $array[1][0]]
		]);
	}
	
	protected function bcc_bank()
	{
		$result = $this->atom->request([
			'url' => 'https://www.bcc.kz/about/kursy-valyut/?bxrand='.time().'564',
			'headers/merge' => [
				'BX-ACTION-TYPE: get_dynamic',
				'BX-CACHE-MODE: HTMLCACHE',
			],
		]);
		
		$this->monotone($result);
		
		$array = $this->atom->regexpAll(
			'<td>([^<]+)<', 
			$this->atom->regexp('Курсыконвертациипоналичнойвалюте(.*?)от20000', $result), 
			1
		);
		
		$this->add('БанкЦентрКредит', [
			[$array[4], $array[5]], 
			[$array[2], $array[3]], 
			[$array[0], $array[1]]
		]);
	}
	
	protected function qazkom_bank()
	{
		$html = $this->atom->request('http://www.qazkom.kz/');
		
		$this->monotone($html);
		
		$array = $this->atom->regexpAll(
			'(RUB|EUR|USD)</td><td>([^<]+)</td><td>([^<]+)</td>', 
			$this->atom->regexp('id="KAZKOM">(.*?)</div>', $html), 
			[2, 3]
		);
		
		$this->add('Казкоммерцбанк', [
			[$array[0][2], $array[1][2]], 
			[$array[0][1], $array[1][1]], 
			[$array[0][0], $array[1][0]]
		]);
	}
	
	protected function atfbank_bank()
	{
		$html = $this->atom->request('https://www.atfbank.kz/');
		
		$this->monotone($html);
		
		$array = $this->atom->regexpAll(
			'(RUB|EUR|USD)</td><td>([^<]+)</td><tdclass=\'rate-td-r\'>([^<]+)</td>', 
			$html, 
			[2, 3]
		);
		
		$this->add('АТФ Банк', [
			[$array[0][1], $array[1][1]], 
			[$array[0][0], $array[1][0]], 
			[$array[0][2], $array[1][2]]
		]);
	}
	
	protected function sberbank_bank()
	{
		$html = $this->atom->request('https://www.sberbank.kz/ru/individuals/rates/currencies?show=graded');
		
		$this->monotone($html);
		
		$array = $this->atom->regexpAll(
			'\((RUB|EUR|USD)\)</h2>(.*?)<tbody><tr><td>([^<]+)</td><td>([^<]+)</td><td>([^<]+)</td>', 
			$this->atom->regexp('<divclass="tabs-content-itemtab-contenttabs-content-item--state-opened"data-tab="all_bank">(.*?)<divclass="tabs-content-itemtab-content"data-tab="almaty_bank">', $html), 
			[4, 5]
		);
		
		$this->add('Сбербанк России', [
			[$array[0][2], $array[1][2]], 
			[$array[0][1], $array[1][1]], 
			[$array[0][0], $array[1][0]]
		]);
	}
	
	protected function tsb_bank()
	{
		$array = $this->atom->request([
			'url' => 'https://www.tsb.kz/ajax_get_tsbrates.php?type=tsb',
			'form' => 'xml',
		]);
		
		$array = $array['exchange_rate'];
		
		$this->add('Цеснабанк', [
			[$array['rub_buy'], $array['rub_sell']], 
			[$array['eur_buy'], $array['eur_sell']], 
			[$array['usd_buy'], $array['usd_sell']]
		]);
	}
}
